import model
import torch
import torch.nn as nn
import torch.optim as optim
from torchvision import datasets, transforms

import time

#net define

net = model.AE()
net.cuda() 

print(net)

# data load

standarization = transforms.Compose([
                    transforms.ToTensor(),
                    transforms.Normalize(mean=(0.1307,),
                                        std=(0.3081,))])
train_data = datasets.MNIST('./../data/', train=True, transform=standarization, download=True)
#test_data = datasets.MNIST('./../data/', train=False, transform=standarization, download=True)

print('training data :', len(train_data))
#print('test data :', len(test_data))

batch_size = 256

train_data_loader = torch.utils.data.DataLoader(train_data, batch_size, shuffle=True)
#test_data_loader = torch.utils.data.DataLoader(test_data, batch_size, shuffle=True)

# optimizer
criterion = nn.MSELoss()
optimizer = optim.Adam(net.parameters())

# training
num_epochs = 200

for epoch in range(num_epochs):
    start_time = time.time()
    running_loss = 0.0

    for img, label in train_data_loader:
        img = img.cuda()
        optimizer.zero_grad()
        hf, recon = net(img)
        loss = criterion(img, recon)
        loss.backward()
        optimizer.step()
        running_loss += loss.item()
    
    end_time = time.time() 
    print('epoch: %2d loss: %.3f elpased time: %.3f' %(epoch+1, running_loss, end_time-start_time))

torch.save(net.state_dict(), './../result/Test_AE.pth')
